/***********************************************************************/
/*                                                                     */
/*  FILE        :echo3048.c                                            */
/*  DATE        :Fri, Apr 23, 2004                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3048F                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.3.0).     */
/*                                                                     */
/***********************************************************************/
#include <ctype.h>
#include <machine.h>
#include "iodefine.h"

#ifndef _STDIO_H
#define EOF (-1)
#endif /*_STDIO_H*/

static void SCI1Init(unsigned char brr);
int SCI1Getc( void );
void SCI1Putc( int c );
void SCI1Puts( const char *source );

void main(void)
{
	int	c;

	SCI1Init( 12 ); /*{[[g38400bpsɐݒ*/
    set_imask_ccr(0);

	/*NWbg̕\*/
	SCI1Puts( "Renesas H8/3048F Test Program for HEW3.\r\n" );
	SCI1Puts( "designed by hamayan.\r\nCopyright (C) hamayan since 2004.\r\n" );

	while(1) /*}CRł肪ȁAmain̖[vB*/
	{
		if( (c = SCI1Getc()) > 0 )
		{
			if( isalpha( c ) ) SCI1Putc( c ^= 0x20 ); /*TvvOł肪ȁA啶/ϊ*/
			else if( c == '\r' )
			{
				SCI1Putc( '\r' );
				SCI1Putc( '\n' );
			}
			else SCI1Putc( c );
		}
	}	
}

/***********************************************************/
/* NMȈ͎LqB                               */
/***********************************************************/
#pragma interrupt(abort)
void abort(void)
{
	
}

/***********************************************************/
/* Mobt@̒`                                       */
/* Ǘłőlunsigned int̍őlƂȂB            */
/***********************************************************/
#define RCV_BUFFER_SIZE	32
typedef struct
{
	unsigned int wptr;
	unsigned int rptr;
	char buffer[RCV_BUFFER_SIZE];
} RCV_BUFFER;

static RCV_BUFFER	rcv; /*̈m*/

/***********************************************************/
/* SCI1̏sBBRR̐ݒlBn[hEGA}j   */
/* AQƂĉB                                    */
/***********************************************************/
static void SCI1Init(unsigned char brr)
{
	int i;

	/* Mobt@̃CfbNX|C^̏ */
	rcv.wptr = rcv.rptr = 0;	

	/* SCI1 */
	P8.DDR = 0x02; /*TXD1[qo͂ɂB*/
	SCI1.SCR.BYTE = 0x00;
	SCI1.SMR.BYTE = 0x00;
	SCI1.BRR = brr;
	for( i = 0; i < 80; i++ ){} /*[ṽRXg6Xe[gA0.375ʕbA*/
	SCI1.SCR.BYTE = 0x70; /* MAMAM݋ */
	i = SCI1.SSR.BYTE;			/*_~[[h*/
	SCI1.SSR.BYTE = 0x80;			/*G[tÕNA*/
}

/***********************************************************/
/* Mobt@ꕶoB                        */
/* Mobt@Ƀf[^́A-1(EOF)ԂB            */
/***********************************************************/
int SCI1Getc( void )
{
	int	ret;

	if( rcv.wptr != rcv.rptr )
	{
		ret = rcv.buffer[ rcv.rptr++ ] & 0xff; /*ꕶo*/
		rcv.rptr %= RCV_BUFFER_SIZE; /*Oobt@̃|C^̊ۂ*/
		return ret;
	}
	return EOF;
}

/***********************************************************/
/* ꕶMB                                         */
/* M荞݂͎gpȂB                                */
/***********************************************************/
void SCI1Putc( int c )
{
	while ( SCI1.SSR.BIT.TDRE == 0 ){}
	SCI1.TDR  = c;
	SCI1.SSR.BIT.TDRE = 0;	/*TDREbit̃NA*/
}

/***********************************************************/
/* 𑗐MB                                       */
/* M荞݂͎gpȂB                                */
/***********************************************************/
void SCI1Puts( const char *source )
{
	while( *source ) SCI1Putc( *source++ );
}

/***********************************************************/
/* Mݏ					                        */
/***********************************************************/
#pragma interrupt(RXI1) /*VA*/
void RXI1( void )
{
	int	c;
	unsigned int next;

	c = SCI1.RDR; /*f[^荞*/
	SCI1.SSR.BIT.RDRF = 0;
	next = rcv.wptr + 1;
	next %= RCV_BUFFER_SIZE;
	/*{́Acobt@eʂ𒲂ׂāAt[ׂB*/
	if( next != rcv.rptr ) /*㏑͋֎~B*/
	{
		rcv.buffer[ rcv.wptr ] = c; /*obt@ɕۑ*/
		rcv.wptr = next;
	}
}

/***********************************************************/
/* G[ݏ                                         */
/***********************************************************/
#pragma interrupt(ERI1) /*VA*/
void ERI1( void )
{
	/*݂ɓR𒲂ׂ*/
	if( SCI1.SSR.BIT.ORER ) SCI1.SSR.BIT.ORER = 0; /*G[݂̏BƏڂKvLB*/
	if( SCI1.SSR.BIT.FER ) SCI1.SSR.BIT.FER = 0; /*G[݂̏BƏڂKvLB*/
	if( SCI1.SSR.BIT.PER ) SCI1.SSR.BIT.PER = 0; /*G[݂̏BƏڂKvLB*/
}

/***********************************************************************/
/*  designed by hamayan                                                */
/*  Copyright (C) hamayan 2004 hamayan@tc5.so-net.ne.jp                */
/***********************************************************************/
